/* (c)2003 Matias Sedalo <s0t4ipv6@sco.com.ar>
   fsco.c for JempiScodes version 0.4 release 1 */

#include "actions.c"    // Funciones de encripcion y desencripcion

/* Inconsistencia entre los push(arg2) del engine y sus datos(arg1) */
#define GOODPUSH(arg1, arg2)if ((int)arg1 > 0x7f && arg2 == 0x6a) { \
    printf("\n [!] Pushb(0x6a) in the engine not correct with %d bytes\n\n", arg1);\
    exit(-1);}

/* Preparo el engine con los opcode variables correspondientes
   y corroboro inconsistencia entre los pushb y pushw */
void _chg_engine(u_char *_engine, int pea_opcode1, int lng_opcode2, int _metodo) 
{
  int	 flag=0;
  int	 x=0;
  int	 op_len=2; 
  u_char bw[4];

  /* El prologue de la funcion del engine no nos interesa */
  method[_metodo].addr += 3;
  snprintf(_engine, method[_metodo].len, "%s", (u_char *)method[_metodo].addr);
  if ( pea_opcode1 > 0x7f ) op_len=3; 

  while ( x < method[_metodo].len ) 
  {
	snprintf(bw, op_len, "%s", _engine);
	if ( flag == 0 && 
		(memcmp(bw, (u_char *)&method[_metodo].op1, op_len-1)==0) )
	{
	/* Corregimos los push/b/w de acuerdo al tama#o de opcode */
	 GOODPUSH((int)pea_opcode1, *(_engine-sizeof(u_char)));
	 memcpy(_engine, (u_char *)&pea_opcode1, op_len-1);
	 // *_engine=(u_char)pea_opcode1; 
	 flag=1;
  	 if ( lng_opcode2 < 0x7f ){op_len=2; snprintf(bw, op_len, "%s", _engine);}
	}
	if ( memcmp(bw, (u_char *)&method[_metodo].op2, op_len-1)==0 )
	{
	 GOODPUSH((int)lng_opcode2, *(_engine-sizeof(u_char)));
	 memcpy(_engine, (u_char *)&lng_opcode2, op_len-1);
	 //*_engine=(u_char)lng_opcode2; 
	 flag+=2;
	} 
	*(_engine+=sizeof(u_char));
	x++;
  }
  switch (flag)
  {
	case 2:
		printf("\n [!] 0x%x from method[].op1, not found in the engine\n", 
			method[_metodo].op1); 
		break;
	case 1:
		printf("\n [!] 0x%x from method[].op2, not found in the engine\n", 
			method[_metodo].op2); 
		break; 
	case 3: return; break;
  }
  printf(" [!] Engine conflict.\n\n");
  exit(-1);
}


/* Extraigo la sco del archivo especificado e imprimo los 20 primero opcodes 
   (int)_popscode(uchar *, int, int) devuelve el tama#o de sco */
int _popscode(u_char *sco, int fd, int anysize) 
{
  int	lenght, x;
  int	count=0, temp=0;
  u_char  pase[4]={0};

  while ( count+3 != anysize ) 
  {
	if (read(fd, pase, 4) < 0) 
	{
	 fprintf(stderr,"\n [!] read(): I can't read the file anymore\n");
	 exit(-1);
    }
	/* leo de a 4 caracteres y busco la forma \xAB */
	if (strncmp((u_char *)SEARCH, pase, 2)==0) 
	{
	 if ( pase[2] != 0 )
		sscanf(pase+sizeof(u_char)*2, "%02x", &sco[temp]);
	 temp++;         // el largo de la sco completa
	}                // sin discriminar.
	count++;
	memset(pase,0x0,4);
	lseek(fd, -3 , SEEK_CUR);        // necesito retroceder 3 bytes
  }
  if ( (lenght=strlen(sco)) == 0 )   // el tama#o de la sco del archivo
  {
      fprintf(stderr,"\n [!] shellcode(): Not found in the file\n");
      exit(-1);
      } else {
      printf(" [*] Content:\t\t[ ");
      for ( x=0; x < OPPL ; x++)  // imprimo solo los primeros 20 opcodes
        fprintf(stdout,"%02x ", sco[x]);
  }
  return lenght;
}


void _starting(int action, int pea, int metodo, int filedi, FILE *filedo) 
{
  u_char	*sco;
  u_char	*sco_new, *engine;
  int		sco_new_len;
  int		sco_len;
  struct	stat fistat;

  if ( (fstat(filedi, &fistat)) < 0 )
        failed("stat()", errno, "");

  if ( (sco=(u_char *)calloc(fistat.st_size + 1, sizeof(u_char))) == NULL )
        { failed("calloc()", errno, ""); }

  printf("\n [*] File size:\t\t%d bytes\n",fistat.st_size );

  sco_len=_popscode((u_char *)sco, filedi, fistat.st_size);

  printf(". . . ]\n");
  printf("\n [*] Shellcode length:\t%03d bytes (%02x)\n", sco_len, sco_len);

  /* aqui tendremos la shellcode ya procesada por la funcion correspondiente 
	 le daremos el doble de tama#o para poder jugar con otros engines */
  if ( (sco_new=(u_char *)calloc(sco_len*2+1, sizeof(u_char))) == NULL )
		{ failed("calloc()", errno, ""); }

  /* memoria en este orden
	 [ sco ][ sco_new ][ engine ] << engine es variable.. 
	 Engine puede crecer en el realloc de abajo ... asi evitamos el memory fault
	 que obtenemos cuando la shellcode sobrepasa el tama#o real del engine */
  if ( (engine=(u_char *)calloc(method[metodo].len + 1, sizeof(u_char))) == NULL )
        { failed("calloc()", errno, ""); }
  
  if (action == 1)	// Encripcion
  {
  	/* generamos la semilla */
  	if ( pea == method[metodo].min ) 
	{
    	pea=_gen_pea(method[metodo].min, method[metodo].max);
    	printf(" [*] Generated seed:\t0x%04x\n", pea);
	}
	/* encode() en actions.c */
	encode((u_char *)sco_new, (u_char *)sco, pea, metodo);
	/* solo en la encripcion preparamos el engine */
 	_chg_engine((u_char *)engine, pea, sco_len, metodo);
  } 
	else			// Desencripcion
  {
	/* decode() en actions.c */
	decode((u_char *)sco_new, (u_char *)sco, pea, metodo);
  }

  /* Para ambas acciones, vamos a depositar la shellcode final
	 en (u_char)engine, si es necesario la ejecutamos e imprimimos */
  sco_new_len=strlen(engine)+strlen(sco_new);
  /* Aqui es donde la shellcode puede sobrepasar al lenght del engine */
  if ( (engine=(u_char *)realloc(engine, sco_new_len+1)) == NULL )
	{ failed("realloc()", errno, ""); }
  /* concatenamos ambas partes en (u_char)engine 
	 en caso de desencripcion nuestra engine estara en NULL */
  memmove(&engine[strlen(engine)], sco_new, strlen(sco_new));
  printf(" [*] New lenght:\t%03d bytes (%02x)\n",sco_new_len, sco_new_len);

  if ( RUNSCODE == 1 ) _gonow((long *)engine);
  printsco((u_char *)engine, sco_new_len, filedo);
}
